package cz.jzitnik.game.sprites.ui;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

import java.util.Objects;

public class Number extends Sprite {
    public enum NumberState {
        ZERO,
        ONE,
        TWO,
        THREE,
        FOUR,
        FIVE,
        SIX,
        SEVEN,
        EIGHT,
        NINE,
    }

    public static String fixForHotbar(String str, int place) {
        var parts = str.split("\n");
        // Make it 50x25
        StringBuilder stringBuilder = new StringBuilder();
        for (int i = 0; i < 24 - 12; i++) {
            stringBuilder.append("\033[0m ".repeat(50)).append("\n");
        }
        for (int i = 0; i < 12; i++) {
            stringBuilder.append("\033[0m ".repeat(50 - 12 * place)).append(parts[i]).append("\033[0m ".repeat(12 * (place-1))).append("\n");
        }
        stringBuilder.append("\033[0m ".repeat(50)).append("\n");

        return stringBuilder.toString();
    }

    private String fix(String x) {
        return x;
        //return x.replaceAll("\033\\[38;5;1;48;5;16m", "\033[0m").replaceAll("\033\\[38;5;16;48;5;16m▓", "\033[0m "); // TODO: Fix issue with sprite size decreasing
    }

    public String getSprite() {
        return fix(Objects.requireNonNull(ResourceLoader.loadResource("breaking/1.ans")));
    }

    public String getSprite(Enum key) {
        return fix(Objects.requireNonNull(ResourceLoader.loadResource(switch (key) {
            case NumberState.ZERO -> "numbers/0.ans";
            case NumberState.ONE -> "numbers/1.ans";
            case NumberState.TWO -> "numbers/2.ans";
            case NumberState.THREE -> "numbers/3.ans";
            case NumberState.FOUR -> "numbers/4.ans";
            case NumberState.FIVE -> "numbers/5.ans";
            case NumberState.SIX -> "numbers/6.ans";
            case NumberState.SEVEN -> "numbers/7.ans";
            case NumberState.EIGHT -> "numbers/8.ans";
            case NumberState.NINE -> "numbers/9.ans";
            default -> throw new IllegalStateException("Unexpected value: " + key);
        })));
    }
}
